-------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 1.11
--  \   \         Application : Virtex-6 FPGA GTH Transceiver Wizard
--  /   /         Filename : v6_gthwizard_v1_11_xlaui.vhd
-- /___/   /\     Timestamp :
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module v6_gthwizard_v1_11_xlaui (a GTH Wrapper)
-- Generated by Xilinx Virtex-6 FPGA GTH Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;


--***************************** Entity Declaration ****************************

entity v6_gthwizard_v1_11_xlaui is
generic
(
    WRAPPER_SIM_GTHRESET_SPEEDUP : integer   := 0      -- Set to 1 to speed up sim reset
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --QUAD0  (X1Y0)

    --------------------------------- Resetdone --------------------------------
    QUAD0_TX_PCS_RESETDONE0_OUT        : out  std_logic;
    QUAD0_RX_PCS_CDR_RESETDONE0_OUT    : out  std_logic;
    QUAD0_TX_PCS_RESETDONE1_OUT        : out  std_logic;
    QUAD0_RX_PCS_CDR_RESETDONE1_OUT    : out  std_logic;
    QUAD0_TX_PCS_RESETDONE2_OUT        : out  std_logic;
    QUAD0_RX_PCS_CDR_RESETDONE2_OUT    : out  std_logic;
    QUAD0_TX_PCS_RESETDONE3_OUT        : out  std_logic;
    QUAD0_RX_PCS_CDR_RESETDONE3_OUT    : out  std_logic;
    --------------------------------- Initdone ---------------------------------
    QUAD0_GTHINITDONE_OUT                       : out  std_logic;    
    --------------------------------- PCS Resets -------------------------------
    QUAD0_TX_PCS_RESET0_IN             : in  std_logic;
    QUAD0_RX_PCS_CDR_RESET0_IN         : in  std_logic;
    QUAD0_TX_PCS_RESET1_IN             : in  std_logic;
    QUAD0_RX_PCS_CDR_RESET1_IN         : in  std_logic;
    QUAD0_TX_PCS_RESET2_IN             : in  std_logic;
    QUAD0_RX_PCS_CDR_RESET2_IN         : in  std_logic;
    QUAD0_TX_PCS_RESET3_IN             : in  std_logic;
    QUAD0_RX_PCS_CDR_RESET3_IN         : in  std_logic;
    --------------------------------- Powerdown --------------------------------
    QUAD0_POWERDOWN0_IN                     : in   std_logic;
    QUAD0_POWERDOWN1_IN                     : in   std_logic;
    QUAD0_POWERDOWN2_IN                     : in   std_logic;
    QUAD0_POWERDOWN3_IN                     : in   std_logic;
    QUAD0_RXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_RXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_RXPOWERDOWN2_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_RXPOWERDOWN3_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_TXPOWERDOWN0_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_TXPOWERDOWN1_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_TXPOWERDOWN2_IN                   : in   std_logic_vector(1 downto 0);
    QUAD0_TXPOWERDOWN3_IN                   : in   std_logic_vector(1 downto 0);
    ------------------------------- Receive Ports ------------------------------
    QUAD0_RXBUFRESET0_IN                    : in   std_logic;
    QUAD0_RXBUFRESET1_IN                    : in   std_logic;
    QUAD0_RXBUFRESET2_IN                    : in   std_logic;
    QUAD0_RXBUFRESET3_IN                    : in   std_logic;
    QUAD0_RXCTRLACK0_OUT                    : out  std_logic;
    QUAD0_RXCTRLACK1_OUT                    : out  std_logic;
    QUAD0_RXCTRLACK2_OUT                    : out  std_logic;
    QUAD0_RXCTRLACK3_OUT                    : out  std_logic;
    QUAD0_RXDATA0_OUT                       : out  std_logic_vector(63 downto 0);
    QUAD0_RXDATA1_OUT                       : out  std_logic_vector(63 downto 0);
    QUAD0_RXDATA2_OUT                       : out  std_logic_vector(63 downto 0);
    QUAD0_RXDATA3_OUT                       : out  std_logic_vector(63 downto 0);
    QUAD0_RXN0_IN                           : in   std_logic;
    QUAD0_RXN1_IN                           : in   std_logic;
    QUAD0_RXN2_IN                           : in   std_logic;
    QUAD0_RXN3_IN                           : in   std_logic;
    QUAD0_RXP0_IN                           : in   std_logic;
    QUAD0_RXP1_IN                           : in   std_logic;
    QUAD0_RXP2_IN                           : in   std_logic;
    QUAD0_RXP3_IN                           : in   std_logic;
    QUAD0_RXSLIP0_IN                        : in   std_logic;
    QUAD0_RXSLIP1_IN                        : in   std_logic;
    QUAD0_RXSLIP2_IN                        : in   std_logic;
    QUAD0_RXSLIP3_IN                        : in   std_logic;
    QUAD0_RXUSERCLKIN0_IN                   : in   std_logic;
    QUAD0_RXUSERCLKIN1_IN                   : in   std_logic;
    QUAD0_RXUSERCLKIN2_IN                   : in   std_logic;
    QUAD0_RXUSERCLKIN3_IN                   : in   std_logic;
    QUAD0_RXUSERCLKOUT0_OUT                 : out  std_logic;
    QUAD0_RXUSERCLKOUT1_OUT                 : out  std_logic;
    QUAD0_RXUSERCLKOUT2_OUT                 : out  std_logic;
    QUAD0_RXUSERCLKOUT3_OUT                 : out  std_logic;
    ------------- Shared Ports - Dynamic Reconfiguration Port (DRP) ------------
    QUAD0_DADDR_IN                          : in   std_logic_vector(15 downto 0);
    QUAD0_DCLK_IN                           : in   std_logic;
    QUAD0_DEN_IN                            : in   std_logic;
    QUAD0_DI_IN                             : in   std_logic_vector(15 downto 0);
    QUAD0_DISABLEDRP_IN                     : in   std_logic;
    QUAD0_DRDY_OUT                          : out  std_logic;
    QUAD0_DRPDO_OUT                         : out  std_logic_vector(15 downto 0);
    QUAD0_DWE_IN                            : in   std_logic;
    ---------------------------- Shared Ports - Other --------------------------
    QUAD0_GTHINIT_IN                        : in   std_logic;
    QUAD0_GTHRESET_IN                       : in   std_logic;
    QUAD0_MGMTPCSLANESEL_IN                 : in   std_logic_vector(3 downto 0);
    QUAD0_MGMTPCSMMDADDR_IN                 : in   std_logic_vector(4 downto 0);
    QUAD0_MGMTPCSRDACK_OUT                  : out  std_logic;
    QUAD0_MGMTPCSRDDATA_OUT                 : out  std_logic_vector(15 downto 0);
    QUAD0_MGMTPCSREGADDR_IN                 : in   std_logic_vector(15 downto 0);
    QUAD0_MGMTPCSREGRD_IN                   : in   std_logic;
    QUAD0_MGMTPCSREGWR_IN                   : in   std_logic;
    QUAD0_MGMTPCSWRDATA_IN                  : in   std_logic_vector(15 downto 0);
    QUAD0_REFCLK_IN                         : in   std_logic;
    QUAD0_REFCLK_OUT                        : OUT  STD_LOGIC;    
    ------------------------------- Transmit Ports -----------------------------
    QUAD0_TXBUFRESET0_IN                    : in   std_logic;
    QUAD0_TXBUFRESET1_IN                    : in   std_logic;
    QUAD0_TXBUFRESET2_IN                    : in   std_logic;
    QUAD0_TXBUFRESET3_IN                    : in   std_logic;
    QUAD0_TXCTRLACK0_OUT                    : out  std_logic;
    QUAD0_TXCTRLACK1_OUT                    : out  std_logic;
    QUAD0_TXCTRLACK2_OUT                    : out  std_logic;
    QUAD0_TXCTRLACK3_OUT                    : out  std_logic;
    QUAD0_TXDATA0_IN                        : in   std_logic_vector(63 downto 0);
    QUAD0_TXDATA1_IN                        : in   std_logic_vector(63 downto 0);
    QUAD0_TXDATA2_IN                        : in   std_logic_vector(63 downto 0);
    QUAD0_TXDATA3_IN                        : in   std_logic_vector(63 downto 0);
    QUAD0_TXN0_OUT                          : out  std_logic;
    QUAD0_TXN1_OUT                          : out  std_logic;
    QUAD0_TXN2_OUT                          : out  std_logic;
    QUAD0_TXN3_OUT                          : out  std_logic;
    QUAD0_TXP0_OUT                          : out  std_logic;
    QUAD0_TXP1_OUT                          : out  std_logic;
    QUAD0_TXP2_OUT                          : out  std_logic;
    QUAD0_TXP3_OUT                          : out  std_logic;
    QUAD0_TXUSERCLKIN0_IN                   : in   std_logic;
    QUAD0_TXUSERCLKIN1_IN                   : in   std_logic;
    QUAD0_TXUSERCLKIN2_IN                   : in   std_logic;
    QUAD0_TXUSERCLKIN3_IN                   : in   std_logic;
    QUAD0_TXUSERCLKOUT0_OUT                 : out  std_logic;
    QUAD0_TXUSERCLKOUT1_OUT                 : out  std_logic;
    QUAD0_TXUSERCLKOUT2_OUT                 : out  std_logic;
    QUAD0_TXUSERCLKOUT3_OUT                 : out  std_logic


);


end v6_gthwizard_v1_11_xlaui;
    
architecture RTL of v6_gthwizard_v1_11_xlaui is

    attribute CORE_GENERATION_INFO : string;
    attribute CORE_GENERATION_INFO of RTL : architecture is "v6_gthwizard_v1_11_xlaui,v6_gthwizard_v1_11,{protocol_file=XLAUI}";

--***************************** Signal Declarations *****************************

    -- ground and tied_to_vcc_i signals
    signal  tied_to_ground_i                :   std_logic;
    signal  tied_to_ground_vec_i            :   std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   :   std_logic;

--*************************** Component Declarations **************************
component v6_gthwizard_v1_11_xlaui_QUAD
generic
(
    QUAD_SIM_GTHRESET_SPEEDUP   : integer   := 0
);
port
(
    TX_PCS_RESETDONE0_OUT              : out  std_logic;
    RX_PCS_CDR_RESETDONE0_OUT          : out  std_logic;
    TX_PCS_RESETDONE1_OUT              : out  std_logic;
    RX_PCS_CDR_RESETDONE1_OUT          : out  std_logic;
    TX_PCS_RESETDONE2_OUT              : out  std_logic;
    RX_PCS_CDR_RESETDONE2_OUT          : out  std_logic;
    TX_PCS_RESETDONE3_OUT              : out  std_logic;
    RX_PCS_CDR_RESETDONE3_OUT          : out  std_logic;
    --------------------------------- Initdone ---------------------------------
    GTHINITDONE_OUT                             : out  std_logic;
    --------------------------------- PCS Resets -------------------------------
    TX_PCS_RESET0_IN                   : in  std_logic;
    RX_PCS_CDR_RESET0_IN               : in  std_logic;
    TX_PCS_RESET1_IN                   : in  std_logic;
    RX_PCS_CDR_RESET1_IN               : in  std_logic;
    TX_PCS_RESET2_IN                   : in  std_logic;
    RX_PCS_CDR_RESET2_IN               : in  std_logic;
    TX_PCS_RESET3_IN                   : in  std_logic;
    RX_PCS_CDR_RESET3_IN               : in  std_logic;
    --------------------------------- Powerdown --------------------------------
    POWERDOWN0_IN                           : in   std_logic;
    POWERDOWN1_IN                           : in   std_logic;
    POWERDOWN2_IN                           : in   std_logic;
    POWERDOWN3_IN                           : in   std_logic;
    RXPOWERDOWN0_IN                         : in   std_logic_vector(1 downto 0);
    RXPOWERDOWN1_IN                         : in   std_logic_vector(1 downto 0);
    RXPOWERDOWN2_IN                         : in   std_logic_vector(1 downto 0);
    RXPOWERDOWN3_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN0_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN1_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN2_IN                         : in   std_logic_vector(1 downto 0);
    TXPOWERDOWN3_IN                         : in   std_logic_vector(1 downto 0);
    ------------------------------- Receive Ports ------------------------------
    RXBUFRESET0_IN                          : in   std_logic;
    RXBUFRESET1_IN                          : in   std_logic;
    RXBUFRESET2_IN                          : in   std_logic;
    RXBUFRESET3_IN                          : in   std_logic;
    RXCTRLACK0_OUT                          : out  std_logic;
    RXCTRLACK1_OUT                          : out  std_logic;
    RXCTRLACK2_OUT                          : out  std_logic;
    RXCTRLACK3_OUT                          : out  std_logic;
    RXDATA0_OUT                             : out  std_logic_vector(63 downto 0);
    RXDATA1_OUT                             : out  std_logic_vector(63 downto 0);
    RXDATA2_OUT                             : out  std_logic_vector(63 downto 0);
    RXDATA3_OUT                             : out  std_logic_vector(63 downto 0);
    RXN0_IN                                 : in   std_logic;
    RXN1_IN                                 : in   std_logic;
    RXN2_IN                                 : in   std_logic;
    RXN3_IN                                 : in   std_logic;
    RXP0_IN                                 : in   std_logic;
    RXP1_IN                                 : in   std_logic;
    RXP2_IN                                 : in   std_logic;
    RXP3_IN                                 : in   std_logic;
    RXSLIP0_IN                              : in   std_logic;
    RXSLIP1_IN                              : in   std_logic;
    RXSLIP2_IN                              : in   std_logic;
    RXSLIP3_IN                              : in   std_logic;
    RXUSERCLKIN0_IN                         : in   std_logic;
    RXUSERCLKIN1_IN                         : in   std_logic;
    RXUSERCLKIN2_IN                         : in   std_logic;
    RXUSERCLKIN3_IN                         : in   std_logic;
    RXUSERCLKOUT0_OUT                       : out  std_logic;
    RXUSERCLKOUT1_OUT                       : out  std_logic;
    RXUSERCLKOUT2_OUT                       : out  std_logic;
    RXUSERCLKOUT3_OUT                       : out  std_logic;
    ------------- Shared Ports - Dynamic Reconfiguration Port (DRP) ------------
    DADDR_IN                                : in   std_logic_vector(15 downto 0);
    DCLK_IN                                 : in   std_logic;
    DEN_IN                                  : in   std_logic;
    DI_IN                                   : in   std_logic_vector(15 downto 0);
    DISABLEDRP_IN                           : in   std_logic;
    DRDY_OUT                                : out  std_logic;
    DRPDO_OUT                               : out  std_logic_vector(15 downto 0);
    DWE_IN                                  : in   std_logic;
    ---------------------------- Shared Ports - Other --------------------------
    GTHINIT_IN                              : in   std_logic;
    GTHRESET_IN                             : in   std_logic;
    MGMTPCSLANESEL_IN                       : in   std_logic_vector(3 downto 0);
    MGMTPCSMMDADDR_IN                       : in   std_logic_vector(4 downto 0);
    MGMTPCSRDACK_OUT                        : out  std_logic;
    MGMTPCSRDDATA_OUT                       : out  std_logic_vector(15 downto 0);
    MGMTPCSREGADDR_IN                       : in   std_logic_vector(15 downto 0);
    MGMTPCSREGRD_IN                         : in   std_logic;
    MGMTPCSREGWR_IN                         : in   std_logic;
    MGMTPCSWRDATA_IN                        : in   std_logic_vector(15 downto 0);
    REFCLK_IN                               : in   std_logic;
    GTH_REFCLK_OUT                          : OUT  STD_LOGIC;    
    ------------------------------- Transmit Ports -----------------------------
    TXBUFRESET0_IN                          : in   std_logic;
    TXBUFRESET1_IN                          : in   std_logic;
    TXBUFRESET2_IN                          : in   std_logic;
    TXBUFRESET3_IN                          : in   std_logic;
    TXCTRLACK0_OUT                          : out  std_logic;
    TXCTRLACK1_OUT                          : out  std_logic;
    TXCTRLACK2_OUT                          : out  std_logic;
    TXCTRLACK3_OUT                          : out  std_logic;
    TXDATA0_IN                              : in   std_logic_vector(63 downto 0);
    TXDATA1_IN                              : in   std_logic_vector(63 downto 0);
    TXDATA2_IN                              : in   std_logic_vector(63 downto 0);
    TXDATA3_IN                              : in   std_logic_vector(63 downto 0);
    TXN0_OUT                                : out  std_logic;
    TXN1_OUT                                : out  std_logic;
    TXN2_OUT                                : out  std_logic;
    TXN3_OUT                                : out  std_logic;
    TXP0_OUT                                : out  std_logic;
    TXP1_OUT                                : out  std_logic;
    TXP2_OUT                                : out  std_logic;
    TXP3_OUT                                : out  std_logic;
    TXUSERCLKIN0_IN                         : in   std_logic;
    TXUSERCLKIN1_IN                         : in   std_logic;
    TXUSERCLKIN2_IN                         : in   std_logic;
    TXUSERCLKIN3_IN                         : in   std_logic;
    TXUSERCLKOUT0_OUT                       : out  std_logic;
    TXUSERCLKOUT1_OUT                       : out  std_logic;
    TXUSERCLKOUT2_OUT                       : out  std_logic;
    TXUSERCLKOUT3_OUT                       : out  std_logic


);
end component;

--********************************* Main Body of Code**************************

begin                       

    tied_to_ground_i                    <= '0';
    tied_to_ground_vec_i(63 downto 0)   <= (others => '0');
    tied_to_vcc_i                       <= '1';


    --------------------------- GTH Instances  -------------------------------



    --_________________________________________________________________________
    --_________________________________________________________________________
    --QUAD0  (X1Y0)

    quad0_v6_gthwizard_v1_11_xlaui_i : v6_gthwizard_v1_11_xlaui_QUAD
    generic map
    (
        QUAD_SIM_GTHRESET_SPEEDUP    =>     WRAPPER_SIM_GTHRESET_SPEEDUP
    )
    port map
    (
         --------------------------------- Resetdone --------------------------------
        TX_PCS_RESETDONE0_OUT          =>  QUAD0_TX_PCS_RESETDONE0_OUT,
        RX_PCS_CDR_RESETDONE0_OUT      =>  QUAD0_RX_PCS_CDR_RESETDONE0_OUT,
        TX_PCS_RESETDONE1_OUT          =>  QUAD0_TX_PCS_RESETDONE1_OUT,
        RX_PCS_CDR_RESETDONE1_OUT      =>  QUAD0_RX_PCS_CDR_RESETDONE1_OUT,
        TX_PCS_RESETDONE2_OUT          =>  QUAD0_TX_PCS_RESETDONE2_OUT,
        RX_PCS_CDR_RESETDONE2_OUT      =>  QUAD0_RX_PCS_CDR_RESETDONE2_OUT,
        TX_PCS_RESETDONE3_OUT          =>  QUAD0_TX_PCS_RESETDONE3_OUT,
        RX_PCS_CDR_RESETDONE3_OUT      =>  QUAD0_RX_PCS_CDR_RESETDONE3_OUT,
        --------------------------------- Initdone ---------------------------------
        GTHINITDONE_OUT                         =>  QUAD0_GTHINITDONE_OUT,
        --------------------------------- PCS Resets -------------------------------
        TX_PCS_RESET0_IN               =>  QUAD0_TX_PCS_RESET0_IN,
        RX_PCS_CDR_RESET0_IN           =>  QUAD0_RX_PCS_CDR_RESET0_IN,
        TX_PCS_RESET1_IN               =>  QUAD0_TX_PCS_RESET1_IN,
        RX_PCS_CDR_RESET1_IN           =>  QUAD0_RX_PCS_CDR_RESET1_IN,
        TX_PCS_RESET2_IN               =>  QUAD0_TX_PCS_RESET2_IN,
        RX_PCS_CDR_RESET2_IN           =>  QUAD0_RX_PCS_CDR_RESET2_IN,
        TX_PCS_RESET3_IN               =>  QUAD0_TX_PCS_RESET3_IN,
        RX_PCS_CDR_RESET3_IN           =>  QUAD0_RX_PCS_CDR_RESET3_IN,
        --------------------------------- Powerdown --------------------------------
        POWERDOWN0_IN                   =>      QUAD0_POWERDOWN0_IN,
        POWERDOWN1_IN                   =>      QUAD0_POWERDOWN1_IN,
        POWERDOWN2_IN                   =>      QUAD0_POWERDOWN2_IN,
        POWERDOWN3_IN                   =>      QUAD0_POWERDOWN3_IN,
        RXPOWERDOWN0_IN                 =>      QUAD0_RXPOWERDOWN0_IN,
        RXPOWERDOWN1_IN                 =>      QUAD0_RXPOWERDOWN1_IN,
        RXPOWERDOWN2_IN                 =>      QUAD0_RXPOWERDOWN2_IN,
        RXPOWERDOWN3_IN                 =>      QUAD0_RXPOWERDOWN3_IN,
        TXPOWERDOWN0_IN                 =>      QUAD0_TXPOWERDOWN0_IN,
        TXPOWERDOWN1_IN                 =>      QUAD0_TXPOWERDOWN1_IN,
        TXPOWERDOWN2_IN                 =>      QUAD0_TXPOWERDOWN2_IN,
        TXPOWERDOWN3_IN                 =>      QUAD0_TXPOWERDOWN3_IN,
        ------------------------------- Receive Ports ------------------------------
        RXBUFRESET0_IN                  =>      QUAD0_RXBUFRESET0_IN,
        RXBUFRESET1_IN                  =>      QUAD0_RXBUFRESET1_IN,
        RXBUFRESET2_IN                  =>      QUAD0_RXBUFRESET2_IN,
        RXBUFRESET3_IN                  =>      QUAD0_RXBUFRESET3_IN,
        RXCTRLACK0_OUT                  =>      QUAD0_RXCTRLACK0_OUT,
        RXCTRLACK1_OUT                  =>      QUAD0_RXCTRLACK1_OUT,
        RXCTRLACK2_OUT                  =>      QUAD0_RXCTRLACK2_OUT,
        RXCTRLACK3_OUT                  =>      QUAD0_RXCTRLACK3_OUT,
        RXDATA0_OUT                     =>      QUAD0_RXDATA0_OUT,
        RXDATA1_OUT                     =>      QUAD0_RXDATA1_OUT,
        RXDATA2_OUT                     =>      QUAD0_RXDATA2_OUT,
        RXDATA3_OUT                     =>      QUAD0_RXDATA3_OUT,
        RXN0_IN                         =>      QUAD0_RXN0_IN,
        RXN1_IN                         =>      QUAD0_RXN1_IN,
        RXN2_IN                         =>      QUAD0_RXN2_IN,
        RXN3_IN                         =>      QUAD0_RXN3_IN,
        RXP0_IN                         =>      QUAD0_RXP0_IN,
        RXP1_IN                         =>      QUAD0_RXP1_IN,
        RXP2_IN                         =>      QUAD0_RXP2_IN,
        RXP3_IN                         =>      QUAD0_RXP3_IN,
        RXSLIP0_IN                      =>      QUAD0_RXSLIP0_IN,
        RXSLIP1_IN                      =>      QUAD0_RXSLIP1_IN,
        RXSLIP2_IN                      =>      QUAD0_RXSLIP2_IN,
        RXSLIP3_IN                      =>      QUAD0_RXSLIP3_IN,
        RXUSERCLKIN0_IN                 =>      QUAD0_RXUSERCLKIN0_IN,
        RXUSERCLKIN1_IN                 =>      QUAD0_RXUSERCLKIN1_IN,
        RXUSERCLKIN2_IN                 =>      QUAD0_RXUSERCLKIN2_IN,
        RXUSERCLKIN3_IN                 =>      QUAD0_RXUSERCLKIN3_IN,
        RXUSERCLKOUT0_OUT               =>      QUAD0_RXUSERCLKOUT0_OUT,
        RXUSERCLKOUT1_OUT               =>      QUAD0_RXUSERCLKOUT1_OUT,
        RXUSERCLKOUT2_OUT               =>      QUAD0_RXUSERCLKOUT2_OUT,
        RXUSERCLKOUT3_OUT               =>      QUAD0_RXUSERCLKOUT3_OUT,
        ------------- Shared Ports - Dynamic Reconfiguration Port (DRP) ------------
        DADDR_IN                        =>      QUAD0_DADDR_IN,
        DCLK_IN                         =>      QUAD0_DCLK_IN,
        DEN_IN                          =>      QUAD0_DEN_IN,
        DI_IN                           =>      QUAD0_DI_IN,
        DISABLEDRP_IN                   =>      QUAD0_DISABLEDRP_IN,
        DRDY_OUT                        =>      QUAD0_DRDY_OUT,
        DRPDO_OUT                       =>      QUAD0_DRPDO_OUT,
        DWE_IN                          =>      QUAD0_DWE_IN,
        ---------------------------- Shared Ports - Other --------------------------
        GTHINIT_IN                      =>      QUAD0_GTHINIT_IN,
        GTHRESET_IN                     =>      QUAD0_GTHRESET_IN,
        MGMTPCSLANESEL_IN               =>      QUAD0_MGMTPCSLANESEL_IN,
        MGMTPCSMMDADDR_IN               =>      QUAD0_MGMTPCSMMDADDR_IN,
        MGMTPCSRDACK_OUT                =>      QUAD0_MGMTPCSRDACK_OUT,
        MGMTPCSRDDATA_OUT               =>      QUAD0_MGMTPCSRDDATA_OUT,
        MGMTPCSREGADDR_IN               =>      QUAD0_MGMTPCSREGADDR_IN,
        MGMTPCSREGRD_IN                 =>      QUAD0_MGMTPCSREGRD_IN,
        MGMTPCSREGWR_IN                 =>      QUAD0_MGMTPCSREGWR_IN,
        MGMTPCSWRDATA_IN                =>      QUAD0_MGMTPCSWRDATA_IN,
        REFCLK_IN                       =>      QUAD0_REFCLK_IN,
	   GTH_REFCLK_OUT				=>	   QUAD0_REFCLK_OUT, -- REFCLK routed through GTH!
        ------------------------------- Transmit Ports -----------------------------
        TXBUFRESET0_IN                  =>      QUAD0_TXBUFRESET0_IN,
        TXBUFRESET1_IN                  =>      QUAD0_TXBUFRESET1_IN,
        TXBUFRESET2_IN                  =>      QUAD0_TXBUFRESET2_IN,
        TXBUFRESET3_IN                  =>      QUAD0_TXBUFRESET3_IN,
        TXCTRLACK0_OUT                  =>      QUAD0_TXCTRLACK0_OUT,
        TXCTRLACK1_OUT                  =>      QUAD0_TXCTRLACK1_OUT,
        TXCTRLACK2_OUT                  =>      QUAD0_TXCTRLACK2_OUT,
        TXCTRLACK3_OUT                  =>      QUAD0_TXCTRLACK3_OUT,
        TXDATA0_IN                      =>      QUAD0_TXDATA0_IN,
        TXDATA1_IN                      =>      QUAD0_TXDATA1_IN,
        TXDATA2_IN                      =>      QUAD0_TXDATA2_IN,
        TXDATA3_IN                      =>      QUAD0_TXDATA3_IN,
        TXN0_OUT                        =>      QUAD0_TXN0_OUT,
        TXN1_OUT                        =>      QUAD0_TXN1_OUT,
        TXN2_OUT                        =>      QUAD0_TXN2_OUT,
        TXN3_OUT                        =>      QUAD0_TXN3_OUT,
        TXP0_OUT                        =>      QUAD0_TXP0_OUT,
        TXP1_OUT                        =>      QUAD0_TXP1_OUT,
        TXP2_OUT                        =>      QUAD0_TXP2_OUT,
        TXP3_OUT                        =>      QUAD0_TXP3_OUT,
        TXUSERCLKIN0_IN                 =>      QUAD0_TXUSERCLKIN0_IN,
        TXUSERCLKIN1_IN                 =>      QUAD0_TXUSERCLKIN1_IN,
        TXUSERCLKIN2_IN                 =>      QUAD0_TXUSERCLKIN2_IN,
        TXUSERCLKIN3_IN                 =>      QUAD0_TXUSERCLKIN3_IN,
        TXUSERCLKOUT0_OUT               =>      QUAD0_TXUSERCLKOUT0_OUT,
        TXUSERCLKOUT1_OUT               =>      QUAD0_TXUSERCLKOUT1_OUT,
        TXUSERCLKOUT2_OUT               =>      QUAD0_TXUSERCLKOUT2_OUT,
        TXUSERCLKOUT3_OUT               =>      QUAD0_TXUSERCLKOUT3_OUT

    );


end RTL;
