--/////////////////////////////////////////////////////////////////////////////
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 1.11
--  \   \         Application : Virtex-6 FPGA GTH Transceiver Wizard
--  /   /         Filename : v6_gthwizard_v1_11_xlaui_gth_reset.vhd
-- /___/   /\     Timestamp :
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module v6_gthwizard_v1_11_xlaui_GTH_RESET
-- Generated by Xilinx Virtex-6 FPGA GTH Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

--***************************** Entity Declaration ****************************

entity v6_gthwizard_v1_11_xlaui_GTH_RESET is
port
(
    DCLK_IN                     : in  std_logic;
    RESET_IN                    : in  std_logic;
    USER_GTHRESET_IN            : in  std_logic;
    CTRLACK_IN                  : in  std_logic;
    MGMTPCSLANESEL_OUT          : out std_logic_vector(3 downto 0);
    MGMTPCSMMDADDR_OUT          : out std_logic_vector(4 downto 0);
    MGMTPCSREGADDR_OUT          : out std_logic_vector(15 downto 0);
    MGMTPCSREGRD_OUT            : out std_logic;
    MGMTPCSREGWR_OUT            : out std_logic;
    MGMTPCSWRDATA_OUT           : out std_logic_vector(15 downto 0);
    GTHINITDONE_IN              : in  std_logic;
    GTHINITDONE_OUT             : out std_logic;
    MGMTPCSRDACK_IN             : in  std_logic;
    MGMTPCSRDDATA_IN            : in  std_logic_vector(15 downto 0);
    DISABLEDRP_OUT              : out  std_logic;
    GTHRESET_OUT                : out std_logic;
    GTHINIT_OUT                 : out std_logic
);

end v6_gthwizard_v1_11_xlaui_GTH_RESET;

architecture RTL of v6_gthwizard_v1_11_xlaui_GTH_RESET is

--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;

--******************************Register Declarations**************************

    signal state                :   std_logic_vector(2 downto 0);
    signal gthreset_out_i       :   std_logic; 
    signal gthinit_out_i        :   std_logic; 
    signal disabledrp_out_i     :   std_logic; 
    signal gthinitdone_out_i    :   std_logic; 
    signal mgmtpcslanesel_out_i :   std_logic_vector(3 downto 0); 
    signal mgmtpcsmmdaddr_out_i :   std_logic_vector(4 downto 0); 
    signal mgmtpcsregaddr_out_i :   std_logic_vector(15 downto 0); 
    signal mgmtpcsregrd_out_i   :   std_logic; 
    signal mgmtpcsregwr_out_i   :   std_logic; 
    signal mgmtpcswrdata_out_i  :   std_logic_vector(15 downto 0); 
    signal wait_count           :   std_logic_vector(4 downto 0); 
    signal count32              :   std_logic_vector(4 downto 0); 
    signal mgmt_op_done         :   std_logic := '0';
    signal por                  :   std_logic := '1';
    signal hold_gthreset_i      :   std_logic; 
    signal mgmt_state           :   std_logic_vector(2 downto 0);

    type array1 is array(5 downto 0) of std_logic_vector(15 downto 0);
    type array2 is array(5 downto 0) of std_logic_vector(3 downto 0);
    signal write_val            : array1; 
    signal addr                 : array1; 
    signal wait_val             : array2; 

    signal wait_ctr             : std_logic_vector(3 downto 0) := "0000";
    signal addr_count           : std_logic_vector(2 downto 0) := "000";

    constant WAIT_STATE         : std_logic_vector(2 downto 0) := "000";
    constant GTHRESET           : std_logic_vector(2 downto 0) := "001";
    constant WAIT_32            : std_logic_vector(2 downto 0) := "010"; 
    constant MGMT_OP            : std_logic_vector(2 downto 0) := "011"; 
    constant WAIT_INITDONE      : std_logic_vector(2 downto 0) := "100"; 
    constant ENABLE_DRP         : std_logic_vector(2 downto 0) := "101"; 
    constant GTHINIT            : std_logic_vector(2 downto 0) := "110";
    constant WAIT_INITDONE2     : std_logic_vector(2 downto 0) := "111";

    constant RESET              : std_logic_vector(2 downto 0) := "000";
    constant MGMT_WRITE         : std_logic_vector(2 downto 0) := "001";
    constant MGMT_WAIT          : std_logic_vector(2 downto 0) := "010";
    constant MGMT_READ          : std_logic_vector(2 downto 0) := "011";
    constant MGMT_ACK           : std_logic_vector(2 downto 0) := "100";
    constant DONE               : std_logic_vector(2 downto 0) := "101";

    constant PLL_CFG0           : std_logic_vector(15 downto 0) := x"9fe0"; 

begin

    GTHINIT_OUT  <= gthinit_out_i;
    GTHRESET_OUT <= gthreset_out_i;
    DISABLEDRP_OUT <= disabledrp_out_i;
    GTHINITDONE_OUT <= gthinitdone_out_i;

    process(DCLK_IN)
    begin
        if(DCLK_IN'event and DCLK_IN = '1') then
            if(RESET_IN = '1') then
                wait_count  <= "10100" after DLY;
            elsif(wait_count>"00000") then
                wait_count  <= wait_count-"00001"  after DLY;
            elsif(USER_GTHRESET_IN='1') then
                wait_count  <= "10100"  after DLY;
            else
                wait_count  <= wait_count  after DLY;
            end if;
        end if;
    end process;  

    hold_gthreset_i  <= '1' when (wait_count>"00000") else
                        '0';
        
    process(DCLK_IN)
    begin
        if(DCLK_IN'event and DCLK_IN = '1') then
            if(RESET_IN = '1') then
                gthinit_out_i  <= '0' after DLY;
                gthreset_out_i <= '1' after DLY;
                disabledrp_out_i <= '1' after DLY;
                gthinitdone_out_i <= '0' after DLY;
                state  <=  GTHRESET after DLY;
                por <= '1' after DLY;
            else
                case state is

                    -- wait here until other state machine tells you to assert gthreset
                    when WAIT_STATE =>
                    
                        gthinit_out_i <= '0' after DLY;
                        gthreset_out_i <= '0' after DLY;
                        por <= '0' after DLY;
                        if (USER_GTHRESET_IN = '0') then
                            state <= WAIT_STATE after DLY;
                        else
                            state <= GTHRESET after DLY;
                        end if;

                    -- assert gthreset for 20 cycles    
                    when GTHRESET =>
                    
                        gthreset_out_i <= '1' after DLY;
                        disabledrp_out_i <= '1' after DLY;
                        gthinitdone_out_i <= '0' after DLY;
                        count32 <= "00000" after DLY;
                        if (hold_gthreset_i = '1' ) then 
                            state <= GTHRESET after DLY;
                        else
                            state <= WAIT_32 after DLY;
                        end if;

                    -- deassert gthreset. wait 32 cycles
                    when WAIT_32 =>
                    
                        gthreset_out_i <= '0' after DLY;
                        if (count32 = "11111") then
                            state <= MGMT_OP after DLY;
                        else 
                            count32 <= count32 + "00001" after DLY;
                            state <= WAIT_32 after DLY;
                        end if;

                    when MGMT_OP =>
                    
                        if (mgmt_op_done = '1') then
                          if (por = '1') then
                             state <= WAIT_INITDONE after DLY;
                          else
                             state <= ENABLE_DRP after DLY;
                          end if;
                        else
                          state <= MGMT_OP after DLY;
                        end if;

                    when WAIT_INITDONE =>

                       if (GTHINITDONE_IN = '1') then                        
                          state <= ENABLE_DRP after DLY;
                       else
                          state <= WAIT_INITDONE after DLY;
                       end if;
                       count32 <= "00000" after DLY;

                    when ENABLE_DRP =>

                       if (count32 = "00010") then                    
                          disabledrp_out_i <= '0' after DLY;
                          state <= GTHINIT after DLY;
                          count32 <= "00000";
                       else
                          state <= ENABLE_DRP after DLY;
                          count32 <= count32 + "00001" after DLY;
                       end if;

                    -- assert gthinit for 1 cycle.                    
                    when GTHINIT =>
                    
                        if (count32 < "00010") then   
                           state <= GTHINIT after DLY;
                           count32 <= count32 + "00001" after DLY;
                        elsif (count32 = "00010") then 
                           gthinit_out_i <= '1' after DLY;
                           state <= GTHINIT after DLY;
                           count32 <= count32 + "00001" after DLY;
                        elsif (count32 = "00011") then 
                           gthinit_out_i <= '0' after DLY;
                           state <= GTHINIT after DLY;
                           count32 <= count32 + "00001" after DLY;
                        elsif (GTHINITDONE_IN = '0') then 
                           state <= WAIT_INITDONE2 after DLY;
                           count32 <= "00000" after DLY;
                        end if;

                    when WAIT_INITDONE2 =>

                        if (GTHINITDONE_IN = '1') then           
                           state <= WAIT_STATE after DLY;
                           gthinitdone_out_i <= '1' after DLY;
                        else
                           state <= WAIT_INITDONE2 after DLY;
                        end if;

                    when others => state <= WAIT_STATE after DLY;
                end case;
            end if;
        end if;
    end process;
    
    addr(0) <= x"C002"; 
    addr(1) <= x"C003"; 
    addr(2) <= x"C003"; 
    addr(3) <= x"C001"; 
    addr(4) <= x"C000"; 
    addr(5) <= x"C000"; 

    write_val(0) <= x"8202"; 
    write_val(1) <= x"000C"; 
    write_val(2) <= x"0008"; 
    write_val(3) <= x"81C0"; 
    write_val(4) <= "1101111111" & PLL_CFG0(5 downto 0); 
    write_val(5) <= "1001111111" & PLL_CFG0(5 downto 0);

    wait_val(0) <= "0100"; 
    wait_val(1) <= "0100"; 
    wait_val(2) <= "1111"; 
    wait_val(3) <= "0100"; 
    wait_val(4) <= "0100"; 
    wait_val(5) <= "0100"; 

    MGMTPCSLANESEL_OUT <= mgmtpcslanesel_out_i;
    MGMTPCSMMDADDR_OUT <= mgmtpcsmmdaddr_out_i;
    MGMTPCSREGADDR_OUT <= mgmtpcsregaddr_out_i;
    MGMTPCSREGRD_OUT <= mgmtpcsregrd_out_i;
    MGMTPCSREGWR_OUT <= mgmtpcsregwr_out_i;
    MGMTPCSWRDATA_OUT <= mgmtpcswrdata_out_i;    
    
    -- MGMT FSM
    process(DCLK_IN)
    begin
        if(DCLK_IN'event and DCLK_IN = '1') then
            if((RESET_IN = '1') or (state /= MGMT_OP)) then
                mgmt_state  <= RESET after DLY;
                addr_count <= "000" after DLY;
                mgmtpcslanesel_out_i <= "0000" after DLY;
                mgmtpcsmmdaddr_out_i <= "00000" after DLY;
                mgmtpcsregaddr_out_i <= x"0000" after DLY;
                mgmtpcsregrd_out_i <= '0' after DLY;
                mgmtpcsregwr_out_i <= '0' after DLY;
                mgmtpcswrdata_out_i <= x"0000" after DLY;
                mgmt_op_done <= '0';
            else
                case mgmt_state is

                    when RESET =>

                        addr_count <= "000" after DLY;
                        mgmt_state <= MGMT_WRITE after DLY;
                        mgmtpcslanesel_out_i <= "0000" after DLY;
                        mgmtpcsmmdaddr_out_i <= "00000" after DLY;
                        mgmtpcsregaddr_out_i <= x"0000" after DLY;
                        mgmtpcsregrd_out_i <= '0' after DLY;
                        mgmtpcsregwr_out_i <= '0' after DLY;
                        mgmtpcswrdata_out_i <= x"0000" after DLY;
                        
                    when MGMT_WRITE =>

                        mgmtpcslanesel_out_i <= "1111" after DLY;
                        mgmtpcsmmdaddr_out_i <= "00001" after DLY;
                        mgmtpcsregaddr_out_i <= addr(to_integer(unsigned(addr_count))) after DLY;
                        mgmtpcsregrd_out_i <= '0' after DLY;
                        mgmtpcsregwr_out_i <= '1' after DLY;
                        mgmtpcswrdata_out_i <= write_val(to_integer(unsigned(addr_count))) after DLY;
                        wait_ctr <= wait_val(to_integer(unsigned(addr_count))) after DLY;
                        mgmt_state <= MGMT_WAIT after DLY;

                    when MGMT_WAIT =>

                        mgmtpcsregwr_out_i <= '0' after DLY;
                        if (wait_ctr > 0) then
                          mgmt_state <= MGMT_WAIT after DLY;
                          wait_ctr <= wait_ctr - "0001" after DLY;
                        else
                          mgmt_state <= MGMT_READ after DLY;
                        end if;

                    when MGMT_READ =>

                        mgmtpcsregrd_out_i <= '1' after DLY;
                        mgmt_state <= MGMT_ACK after DLY;

                    when MGMT_ACK =>

                        mgmtpcsregrd_out_i <= '0' after DLY;
                        if (MGMTPCSRDACK_IN = '1') then
                           mgmt_state <= DONE after DLY;
                        else
                          mgmt_state <= MGMT_ACK after DLY;
                        end if;

                    when DONE =>
                        if (addr_count < "101") then
                           addr_count <= addr_count + "001" after DLY;
                           mgmt_state <= MGMT_WRITE after DLY;
                        else
                          mgmt_state <= DONE after DLY;
                          mgmt_op_done <= '1';
                        end if;

                    when others => mgmt_state <= RESET after DLY;
                end case;
            end if;
        end if;
    end process;

end RTL;

