--/////////////////////////////////////////////////////////////////////////////
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 1.11
--  \   \         Application : Virtex-6 FPGA GTH Transceiver Wizard
--  /   /         Filename : v6_gthwizard_v1_11_xlaui_gth_tx_pcs_reset.vhd
-- /___/   /\     Timestamp :
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module v6_gthwizard_v1_11_xlaui_GTH_TX_PCS_RESET
-- Generated by Xilinx Virtex-6 FPGA GTH Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use std.textio.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

--***************************** Entity Declaration ****************************

entity v6_gthwizard_v1_11_xlaui_GTH_TX_PCS_RESET is
port
(
    TXUSERCLK_IN                    : in std_logic; 
    RESET_IN                        : in std_logic;
    TXPCSRESET_IN                   : in std_logic;
    TXCTRLACK_IN                    : in std_logic;
    TXBUFRESET_OUT                  : out std_logic;
    TXPOWERDOWN_OUT                 : out std_logic;
    TXPCSRESETDONE_OUT              : out std_logic
);

end v6_gthwizard_v1_11_xlaui_GTH_TX_PCS_RESET;


architecture RTL of v6_gthwizard_v1_11_xlaui_GTH_TX_PCS_RESET is

--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;

--*******************************Register Declarations*************************

    signal  txpowerdown_down_r          :   std_logic := '0';
    signal  wait_for_pwrdwn_ack_r       :   std_logic := '0';
    signal  txbufreset_r                :   std_logic := '0';
    signal  txpowerdown_up_r            :   std_logic := '0';
    signal  wait_for_ack_r              :   std_logic := '0'; 
    signal  wait_state_r                :   std_logic := '0';

--*******************************Wire Declarations****************************

    signal  next_txpowerdown_down_c     :   std_logic;
    signal  next_wait_for_pwrdwn_ack_c  :   std_logic;
    signal  next_txbufreset_c           :   std_logic;
    signal  next_txpowerdown_up_c       :   std_logic;
    signal  next_wait_for_ack_c         :   std_logic; 
    signal  next_wait_state_c           :   std_logic;
    signal  txctrlack_i                 :   std_logic;
    signal  txpcsreset_i                :   std_logic;

begin

    -- State registers
    process(TXUSERCLK_IN)
    begin
        if(TXUSERCLK_IN'event and TXUSERCLK_IN = '1') then
            if(RESET_IN = '1') then
                txpowerdown_down_r     <=  '0' after DLY;
                wait_for_pwrdwn_ack_r  <=  '0' after DLY;
                txbufreset_r           <=  '0' after DLY;
                txpowerdown_up_r       <=  '0' after DLY;
                wait_for_ack_r         <=  '1' after DLY;
                wait_state_r           <=  '0' after DLY;
            else
                txpowerdown_down_r     <=  next_txpowerdown_down_c after DLY;
                wait_for_pwrdwn_ack_r  <=  next_wait_for_pwrdwn_ack_c after DLY;
                txbufreset_r           <=  next_txbufreset_c after DLY;
                txpowerdown_up_r       <=  next_txpowerdown_up_c after DLY;
                wait_for_ack_r         <=  next_wait_for_ack_c after DLY;
                wait_state_r           <=  next_wait_state_c after DLY;
            end if;
        end if;
    end process;

    next_txpowerdown_down_c     <=   (txpowerdown_down_r and (not txctrlack_i)) or (wait_state_r and (not txpcsreset_i));

    next_wait_for_pwrdwn_ack_c  <=   (txpowerdown_down_r and txctrlack_i) or (wait_for_pwrdwn_ack_r and txctrlack_i);
    
    next_txbufreset_c           <=   (wait_for_pwrdwn_ack_r and (not txctrlack_i));

    next_txpowerdown_up_c       <=   (txbufreset_r and (not txctrlack_i)) or (txpowerdown_up_r and (not txctrlack_i));

    next_wait_for_ack_c         <=   (txpowerdown_up_r and txctrlack_i) or (wait_for_ack_r and (not txpcsreset_i));

    next_wait_state_c           <=   (wait_for_ack_r and txpcsreset_i) or (wait_state_r and txpcsreset_i);

    --Input/Output Assignments
    TXPOWERDOWN_OUT            <=   txpowerdown_down_r or txbufreset_r;
    txctrlack_i                <=   TXCTRLACK_IN;
    txpcsreset_i               <=   TXPCSRESET_IN;
    TXBUFRESET_OUT             <=   txbufreset_r;
    TXPCSRESETDONE_OUT         <=   wait_for_ack_r and (not RESET_IN);
    

end RTL;

