--
-- Copyright (c) 2015 Aitia International Inc.
--
-- See the file "/doc/license.txt" for information on usage and redistribution
-- of this file, and for a DISCLAIMER OF ALL WARRANTIES.
-- 
--------------------------------------------------------------------------------
-- Company: Aitia
-- Engineer: Laszlo Kovacs
--
-- Create Date:   08:05:16 06/03/2016
-- Design Name:   
-- Module Name:   /mnt/Adat2/MUNKA/SGA_CGEP/sim/sim_100G.vhd
-- Project Name:  sim
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- TestBench for 40G Ethernet PCS/PMA+MAC full model simulation
-- including Virtex 6 device specific transcievers
-- Contains a simple traffic geneartor
-- Serial GTH Serdes-level input/outputs are in loopback!
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE work.tuw.all; 
USE work.xlgpcspma_v6.all;
USE work.xlg_framegen_pkg.all; 
 
ENTITY sim_40G_full IS
END sim_40G_full;
 
ARCHITECTURE behavior OF sim_40G_full IS 
 
   --Inputs
   signal Q0_REFCLK_N : std_logic := '0';
   signal Q0_REFCLK_P : std_logic := '0';
   signal Q1_REFCLK_N : std_logic := '0';
   signal Q1_REFCLK_P : std_logic := '0';
   signal Q2_REFCLK_N : std_logic := '0';
   signal Q2_REFCLK_P : std_logic := '0';
   signal XLG_ExtClk : std_logic := '0';
   SIGNAL DRP_Clk : STD_LOGIC := '0';
   signal RXN_GTH : std_logic_vector(4-1 downto 0) := (others => '0');
   signal RXP_GTH : std_logic_vector(4-1 downto 0) := (others => '0');
   signal XLG_TXData : std_logic_vector(5*64-1 downto 0) := (others => '0');
   signal XLG_TXMod64 : std_logic_vector(5 downto 0) := (others => '0');
   signal XLG_TXDv : std_logic := '0';
   signal XLG_TXSof : std_logic := '0';
   signal XLG_TXEof : std_logic := '0';
   signal XLG_Rst : std_logic := '0';
   signal XLG_signal_ok : std_logic := '0';

 	--Outputs
   signal TXN_GTH : std_logic_vector(4-1 downto 0);
   signal TXP_GTH : std_logic_vector(4-1 downto 0);
   signal XLG_Clk_RX : std_logic;
   signal XLG_Clk_TX : std_logic;
   signal XLG_RXData : std_logic_vector(5*64-1 downto 0);
   signal XLG_RXMod64 : std_logic_vector(5 downto 0);
   signal XLG_RXDv : std_logic;
   signal XLG_RXSof : std_logic;
   signal XLG_RXEof : std_logic;
   signal XLG_RXErr : std_logic;
   signal XLG_RXCRCErr : std_logic;
   signal XLG_aligned : std_logic;
   signal XLG_initdone : std_logic;
   SIGNAL PCS_RXSof : STD_LOGIC;

SIGNAL Cfg_Wr			: STD_LOGIC;
SIGNAL XLG_TXAv		: STD_LOGIC;
SIGNAL RXPck_Cntr 	: STD_LOGIC_VECTOR(4*8-1 downto 0) := (others => '0');
SIGNAL MACRx_Loss 	: STD_LOGIC := '0';


   -- Clock period definitions
   constant XLG_ExtClk_period : time := 10 ns; -- 50 MHz
   constant GTH_Clk_period : time := 6.4 ns; -- 156.25M GTH reference clock
--   constant GTH_bClk_period : time := 96.97 ps; -- 156.25Mx66b GTH bit clock
   constant GTH_bClk_period : time := 96970 fs; -- 156.25Mx66b GTH bit clock
 
BEGIN
 
XLG_signal_ok	<= '1'; 
-- LOOP PHYSICAL!
RXN_GTH		<= TXN_GTH;
RXP_GTH		<= TXP_GTH;


	-- Instantiate the Unit Under Test (UUT)
   uut: ETH_40G_v6 PORT MAP (
          REFCLK_N 		=> Q0_REFCLK_N,
          REFCLK_P 		=> Q0_REFCLK_P,
		DRP_CLK		=> DRP_Clk,
          RXN_GTH 		=> RXN_GTH,
          RXP_GTH 		=> RXP_GTH,
          TXN_GTH 		=> TXN_GTH,
          TXP_GTH 		=> TXP_GTH,
		--
          XLG_RXData 	=> XLG_RXData,
          XLG_RXMod40 	=> XLG_RXMod64,
          XLG_RXDv 		=> XLG_RXDv,
          XLG_RXSof 	=> XLG_RXSof,
          XLG_RXEof 	=> XLG_RXEof,
          XLG_RXErr 	=> XLG_RXErr,
		XLG_RXCRCErr	=> XLG_RXCRCErr,
		PCS_RXSof		=> PCS_RXSof,
		--
          XLG_TXAv 		=> XLG_TXAv,
		XLG_TXData 	=> XLG_TXData,
          XLG_TXMod40 	=> XLG_TXMod64,
          XLG_TXDv 		=> XLG_TXDv,
          XLG_TXSof 	=> XLG_TXSof,
          XLG_TXEof 	=> XLG_TXEof,
		--
          XLG_Clk_RX	=> XLG_Clk_RX,
          XLG_Clk_TX	=> XLG_Clk_TX,	
		XLG_CDR_Rst	=> XLG_Rst,
          XLG_Rst 		=> XLG_Rst,
          XLG_signal_ok 	=> XLG_signal_ok,
		XLG_initdone	=> XLG_initdone,
          XLG_aligned 	=> XLG_aligned
        );

-- Simple Frame generator
UCTxG: XLG_FrameGen 
	PORT MAP(
	clk 						=> XLG_Clk_TX,
	Rst 						=> XLG_Rst,
	-- Config
	Cfg_Frlen					=> X"0040", --CGCfg_Frlen, 
	Cfg_Ifslen				=> X"0000", --CGCfg_Ifslen, 
	Cfg_Wr					=> Cfg_Wr,
	--
	XLG_TxAv					=> XLG_TXAv,
	XLG_TXData 				=> XLG_TXData(4*64-1 downto 0*64),
	XLG_TXDv 					=> XLG_TXDv,
	XLG_TXSof					=> XLG_TXSof,
	XLG_TXEof					=> XLG_TXEof,
	XLG_TXMod64				=> XLG_TXMod64
	); 

-- Detect frame-loss
URXLoss: PROCESS(XLG_Clk_RX)
BEGIN
IF (XLG_Clk_RX'event AND XLG_Clk_RX = '1') THEN
	IF (XLG_RXSOF = '1' AND XLG_RXDV = '1') THEN
		IF (RXPck_Cntr /= XLG_RXData(4*64-1 downto 4*64-32)) THEN -- Packet number is in last 4 byte positions
			RXPck_Cntr	<= XLG_RXData(4*64-1 downto 4*64-32) + X"00000001";
			MACRX_Loss 	<= '1';
		ELSE
			INCR(RXPck_Cntr);
			MACRX_Loss 	<= '0';
		END IF;
	ELSE
		MACRX_Loss 	<= '0';
	END IF;
END IF;
END PROCESS;
PROCESS(DRP_Clk)
BEGIN
IF (DRP_Clk'event AND DRP_Clk='1') THEN
IF (XLG_Rst = '1') THEN
	Cfg_Wr	<= '0';
ELSE
	Cfg_Wr	<= '1';
END IF;
END IF;
END PROCESS;

 
DRP_Clk	<= XLG_ExtClk;

   -- Clock process definitions
   XLG_ExtClk_process :process
   begin
		XLG_ExtClk <= '0';
		wait for XLG_ExtClk_period/2;
		XLG_ExtClk <= '1';
		wait for XLG_ExtClk_period/2;
   end process;
 
   XLG_Clk_process :process
   begin
		Q0_REFCLK_N <= '0';
		Q0_REFCLK_P <= '1';
		Q1_REFCLK_N <= '0';
		Q1_REFCLK_P <= '1';
		Q2_REFCLK_N <= '0';
		Q2_REFCLK_P <= '1';
		wait for GTH_Clk_period/2;
		Q0_REFCLK_N <= '1';
		Q0_REFCLK_P <= '0';
		Q1_REFCLK_N <= '1';
		Q1_REFCLK_P <= '0';
		Q2_REFCLK_N <= '1';
		Q2_REFCLK_P <= '0';
		wait for GTH_Clk_period/2;
   end process;
 


   -- Stimulus process
   stim_proc: process
   begin		
	XLG_Rst	<= '1';
	wait until XLG_initdone = '1'; 
      -- hold reset state for 100 ns after GTH initialized
     wait for 100 ns;	
	XLG_Rst	<= '0';
      -- insert stimulus here 
      wait;
   end process;

END;
